require 'entropy'

class Read_deletion < Read_indel
	def initialize( read, offset, start, length )
		super(read, offset, start, length)
	end


	def dist_3
		return @offset + 1 if @read.dir == :'-'
		return @read.length - @offset -1
	end


	def neighbor_entropy
		bases = Ref_seq.instance.get_base_range(@read.ref, @start_pos-10, end_pos+10)
		return entropy(bases, @length)
	end


	def nqs #require quality >= 15 for surrounding 5 bases
		#check 5 upstream bases
		lower = @offset-4
		upper = @offset
		if(upper >= 0)
			lower = 0 if lower < 0
			begin
				@read.qual_array[lower..upper].each do |qual|
					return 0 if qual < 15
				end
			rescue
				raise "Error with nqs check: lower:#{lower} upper:#{upper} qual_array:#{@read.qual_array}  --  #{@read.qual_array[lower..upper]}\n#{$!}"
			end
		end
		#check 5 downstream bases
		lower = @offset+1
		upper = @offset +5
		if(lower < @read.qual_array.length)
			upper = @read.qual_array.length - 1  if upper >= @read.qual_array.length
			@read.qual_array[lower..upper].each do |qual|
				return 0 if qual < 15
			end
		end
		return 1
	end


    def avnbq
        #Returns average base quality score around the indel
        lower = @offset-4
        upper = @offset+4
        if lower < 0
            lower=0
        end
        if upper > @read.qual_array.length - 1
            upper=@read.qual_array.length - 1
        end
        total_qual=0
        @read.qual_array[lower..upper].each do |qual|
            total_qual = total_qual+qual
        end
        return total_qual/(upper-lower+1)
    end



	def ref_seq
		return Ref_seq.instance.get_base_range(@read.ref, @start_pos, end_pos)
	end


	def alt_seq
		return Ref_seq.instance.get_base(@read.ref, @start_pos)
	end

	def end_pos
		return @start_pos+@length
	end


	def read_end_pos
		return @offset + 1
	end


	def is_deletion
		return true
	end


	def possible_homopolymer
		del_bases = ref_seq
		str = "#{@read.seq[@offset,1]}#{del_bases}#{@read.seq[read_end_pos,1]}"
		str.squeeze!
		return 0 if str.length > 2
		return 1
	end



	def to_s
		return "#{@read.ref}:#{@start_pos}D#{@length}"
	end

    
end
