
class PileupLine

	attr_reader :chr, :coor, :refBase, :pos, :format, :total_depth, :ref_depth

	def initialize(line)
		values = line.strip.split("\t")
		@chr = values[0]
		@coor = values[1]
		@refBase = values[2]
		@pos = "#{@chr}_#{@coor}"
		@format = "GT:VR:RR:DP:GQ"
		@total_depth = values[3].to_i
		@ref_depth = values[4].count(".,").to_i - values[4].count("+-").to_i
	end

	def genotype
		return './.'
	end

	def var_depth
		return '.'
	end

	def genotype_qual
		return '.'
	end
	
	def genotypeInfo
		return "#{self.genotype}:#{self.var_depth}:#{@ref_depth}:#{@total_depth}:#{self.genotype_qual}"
	end

end
